/**
 * $RCSfile$
 * version $Revision$
 * created 07.06.2008 11:20:03 by kunina
 * last modified $Date$ by $Author$
 * (C) ООО Крипто-Про 2004-2008.
 *
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package Applet_samples.AppletNew;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;

/**
 * Выбор контейнера.
 *
 * @author Copyright 2004-2008 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class JCPKeyPane extends JFrame {

private JPanel page;
private JButton okButton;
private JComboBox keyBox;
private JPanel stores;
private ButtonGroup group;
private Component root;
private Image icon;
private JTextField textF;
private GridBagConstraints gbc;

/**
 * Конструктор
 *
 * @param tit заголовок
 * @param ico иконка
 * @param location относительно какого компонента
 * @param isResizable изменяемы ли размеры
 * @param text поле для вывода информации о ключе (хранилище/имя)
 */
public JCPKeyPane(String tit, Image ico, Component location,
                  boolean isResizable, JTextField text) {
    setupUI();
    icon = ico;
    root = location;
    textF = text;
    keyBox.setPreferredSize(
            new Dimension(150, keyBox.getPreferredSize().height));
    keyBox.setMaximumSize(keyBox.getPreferredSize());
    rButtonPanel("Stores", Processor.getStores(), stores);
    okButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            onOkButton();
        }
    });
    getContentPane().add(getRootComponent());
    setTitle(tit);
    setIconImage(ico);
    setLocationRelativeTo(location);
    setResizable(isResizable);
}

/**
 * выбор контейнера
 */
private void onOkButton() {
    if (keyBox.getSelectedItem() != null) {
        Processor.setKeyAlias(keyBox.getSelectedItem().toString());
        dispose();
        final PassPane pp = new PassPane("Password", icon, root, false, textF);
        pp.pack();
        pp.show();
    } else {
        JOptionPane.showMessageDialog(page, new String[]{
                "No key is selected"
        }, "Error", 0);
    }
}

/**
 * панель с радио-кнопками
 *
 * @param titl название
 * @param options подписи к кнопкам
 * @param panel панель для размещения
 */
protected void rButtonPanel(String titl, String[] options, JPanel panel) {
    panel.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(), titl));
    panel.setLayout(new BoxLayout(panel, 1));
    group = new ButtonGroup();
    final ActionListener listener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            viewKeys();
        }
    };
    for (int i = 0; i < options.length; i++) {
        final JRadioButton button = new JRadioButton(options[i]);
        button.setActionCommand(options[i]);
        panel.add(button);
        group.add(button);
        button.setSelected(i == 0);
        button.addActionListener(listener);
    }
}

/**
 * Просмотр ключей
 */
private void viewKeys() {
    keyBox.removeAllItems();
    final String storeName = group.getSelection().getActionCommand();
    Processor.setKeyStoreName(storeName);
    final Enumeration aliases = Processor.getAliases(storeName);
    while (aliases.hasMoreElements()) {
        keyBox.addItem(aliases.nextElement());
    }
}

/**
 * Получение панели с элементами
 *
 * @return панель
 */
protected JComponent getRootComponent() {
    return page;
}

/**
 * Графический интерфейс
 */
private void setupUI() {
    page = new JPanel();
    page.setLayout(new GridBagLayout());
    keyBox = new JComboBox();
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.fill = 2;
    gbc.insets = new Insets(5, 5, 5, 5);
    page.add(keyBox, gbc);
    stores = new JPanel();
    stores.setLayout(new GridBagLayout());
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.fill = 1;
    gbc.insets = new Insets(5, 5, 0, 5);
    page.add(stores, gbc);
    okButton = new JButton();
    okButton.setText("Ok");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.fill = 2;
    gbc.insets = new Insets(0, 5, 0, 5);
    page.add(okButton, gbc);
}
}