/**
 * $RCSfile$
 * version $Revision$
 * created 06.06.2008 18:12:46 by kunina
 * last modified $Date$ by $Author$
 * (C) ООО Крипто-Про 2004-2008.
 *
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package Applet_samples.AppletNew;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Ввод пароля.
 *
 * @author Copyright 2004-2008 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class PassPane extends JFrame {

private JPanel page;
private JPasswordField passField;
private JButton okButton;
private JCheckBox passCheckBox;
private GridBagConstraints gbc;

/**
 * Конструктор
 *
 * @param tit заголовок
 * @param ico иконка
 * @param location относительно какого компонента
 * @param isResizable изменяемы ли размеры
 * @param text поле для вывода информации о ключе (хранилище/имя)
 */
public PassPane(String tit, Image ico, Component location, boolean isResizable,
                final JTextField text) {
    setupUI();
    passCheckBox.addActionListener(new ActionListener() {

        public void actionPerformed(ActionEvent e) {
            if (passCheckBox.isSelected())
                passField.setEnabled(true);
            else
                passField.setEnabled(false);
        }
    });
    okButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            final char[] pass;
            if (!passCheckBox.isSelected())
                pass = null;
            else
                pass = passField.getPassword();
            Processor.setKeyPassword(pass);
            if (Processor.readKey()) {
                text.setText(Processor.getKeyStoreName() + " / " +
                        Processor.getKeyAlias());
                dispose();
            } else {
                JOptionPane.showMessageDialog(page, new String[]{
                        "Password is incorrect"
                }, "Error", 0);
                Processor.cleanAll();
                text.setText("");
                dispose();
            }
        }
    });
    getContentPane().add(getRootComponent());
    setTitle(tit);
    setIconImage(ico);
    setLocationRelativeTo(location);
    setResizable(isResizable);
}

/**
 * Получение панели с элементами
 *
 * @return панель
 */
public JComponent getRootComponent() {
    return page;
}

/**
 * Графический интерфейс
 */
private void setupUI() {
    page = new JPanel();
    page.setLayout(new GridBagLayout());
    passField = new JPasswordField();
    passField.setEnabled(false);
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.anchor = 17;
    gbc.fill = 2;
    gbc.ipadx = 100;
    gbc.insets = new Insets(5, 5, 5, 5);
    page.add(passField, gbc);
    okButton = new JButton();
    okButton.setText("Ok");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 3;
    gbc.fill = 2;
    gbc.ipadx = 100;
    gbc.insets = new Insets(0, 5, 5, 5);
    page.add(okButton, gbc);
    final JLabel label = new JLabel();
    label.setText("Input container password");
    label.setHorizontalAlignment(0);
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.fill = 2;
    gbc.insets = new Insets(5, 5, 0, 5);
    page.add(label, gbc);
    passCheckBox = new JCheckBox();
    passCheckBox.setSelected(false);
    passCheckBox.setText("Container with password");
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.anchor = 17;
    gbc.insets = new Insets(5, 5, 0, 5);
    page.add(passCheckBox, gbc);
}
}