/**
 * $RCSfileContainerXAdES2001.java,v $
 * version $Revision: 36379 $
 * created 22.06.2015 12:50 by afevma
 * last modified $Date: 2012-05-30 12:19:27 +0400 (Ср, 30 май 2012) $ by $Author: afevma $
 * <p/>
 * Copyright 2004-2015 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package CAdES.configuration.container;

import CAdES.configuration.Configuration;
import ru.CryptoPro.JCPxml.Consts;
import xades.config.IXAdESContainer;

/**
 * Служебный класс ContainerXAdES2001 для подписи
 * на алгоритме ГОСТ Р 34.10-2001 формата XAdES.
 *
 * @author Copyright 2004-2015 Crypto-Pro. All rights reserved.
 * @.Version
 * @see xades.XAdESExample
 */
public class ContainerXAdES2001 implements ISignatureContainer, IXAdESContainer {

    @Override
    public String getDigestMethod() {
        return Consts.URI_GOST_DIGEST;
    }

    @Override
    public String getSignatureMethod() {
        return Consts.URI_GOST_SIGN;
    }

    @Override
    public String getAlias() {
        return "GostUsr";
    }

    @Override
    public char[] getPassword() {
        return null;
    }

    @Override
    public String getTsaAddress() {
        return Configuration.TSA_DEFAULT_ADDRESS;
    }

}
