/**
 * Copyright 2004-2012 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package CAdES.configuration.container;

/**
 * Служебный интерфейс ISignatureContainer предназначен
 * для создания классов, содержащих контейнеры на различных
 * алгоритмах.
 *
 * 16/12/2013
 *
 */
public interface ISignatureContainer {

    /**
     * Получение алиаса ключа.
     *
     * @return алиас ключа.
     */
    public String getAlias();

    /**
     * Получение пароля для доступа к ключу.
     *
     * @return пароль для доступа к ключу.
     */
    public char[] getPassword();

    /**
     * Получение адреса TSA службы.
     *
     * @return адрес службы.
     */
    public String getTsaAddress();

}
