/**
 * $RCSfileJCSPEnvelopedDataAsByteArrayExample.java,v $
 * version $Revision: 36379 $
 * created 24.07.2014 11:03 by afevma
 * last modified $Date: 2012-05-30 12:19:27 +0400 (Ср, 30 май 2012) $ by $Author: afevma $
 *
 * Copyright 2004-2014 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package CAdES.enveloped;

import ru.CryptoPro.AdES.AdESConfig;

/**
 * Пример создания и расшифрования подписи Enveloped CMS
 * из строки с помощью провайдера Java CSP.
 *
 * @author Copyright 2004-2014 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class JCSPEnvelopedDataAsByteArrayExample {

    /**
     *
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {

        /**
         * Для того, чтобы использовать другой провайдер подписи и
         * хеширования, например, Java CSP вместо JCP, можно передать
         * его имя как в статическую функцию:
         * AdESConfig.setDefaultProvider("JCSP");
         *
         * либо как параметр:
         * System.setProperty("ru.CryptoPro.defaultProv", "JCSP");
         * По умолчанию всегда используется провайдер, заданный в
         * панели JCP.
         */

        // Задаем провайдер подписи и хеширования Java CSP.
        System.setProperty(AdESConfig.DEFAULT_PROVIDER, "JCSP");

        // Примеры
        EnvelopedDataAsByteArrayExample.main(null);
    }

}
