//
//  ,    , 
//         
//   .
//
//  -   
//     .
//
//------------------------------------------------------------------------------
//   script-     
//      CAPICOM.
//------------------------------------------------------------------------------

//   .
//    (   VBS    CSP)
//     ,
//        UTF-16LE .
//      java (, CMS.CMSVerify...)
//  (content)   UTF-16LE.
//       java
//   ,      
//UTF-16LE  .


var ForReading = 1, ForWriting = 2;

// .
var Unknown = 0;
var Sign = 1;
var CoSign = 2;
var Verify = 3;

// CAPICOM .
var CAPICOM_CURRENT_USER_STORE = 2;

var CAPICOM_CERTIFICATE_FIND_EXTENDED_PROPERTY = 6;
var CAPICOM_CERTIFICATE_FIND_TIME_VALID = 9;

var CAPICOM_VERIFY_SIGNATURE_ONLY = 0;

var CAPICOM_CERTIFICATE_INCLUDE_CHAIN_EXCEPT_ROOT = 0;

var CAPICOM_PROPID_KEY_PROV_INFO = 2;

//   .
var Command = Unknown;
var StoreLocation = null;
var VerifyFlag = CAPICOM_VERIFY_SIGNATURE_ONLY;
var IncludeOption = CAPICOM_CERTIFICATE_INCLUDE_CHAIN_EXCEPT_ROOT;
var bDetached = true;

// 

// .
var FileNames;

//      ,  script    CScript.exe.
if (WScript.FullName.toLowerCase().indexOf("cscript.exe") == -1) {
    var ss = "This script can only be executed by CScript.exe.\n" +
             "You can either:\n" +
             "1. Set CScript.exe as the default (Run CScript //h:cscript), or\n" +
             "2. Run CScript.exe directly as in, CScript " +
             WScript.ScriptName + ".";
    WScript.Echo(ss);
    WScript.Quit(-1);
}

//   .
ParseCommandLine();

//  ,      .
var Signer = new ActiveXObject("CAPICOM.Signer");

//    .
if (Command == Sign || Command == CoSign) {
    var iIndex;
    var Store;
    var Certificates;
    var StoreName = "MY";

    //   .
    Store = new ActiveXObject("CAPICOM.Store");

    StoreLocation = CAPICOM_CURRENT_USER_STORE;

    Store.Open(StoreLocation, StoreName);

    //     ,     ,
    //     .
    Certificates = Store.Certificates;

    //     ,     .
    if (Certificates.Count > 0) {
        Certificates =
        Certificates.Find(CAPICOM_CERTIFICATE_FIND_EXTENDED_PROPERTY, CAPICOM_PROPID_KEY_PROV_INFO);
    }

    //     ,    .
    if (Certificates.Count > 0) {
        Certificates = Certificates.Find(CAPICOM_CERTIFICATE_FIND_TIME_VALID);
    }

    //    .       ,
    //        (   ).
    if (Certificates.Count == 0) {
        WScript.Echo("Error: No signing certificate can be found.");
        WScript.Quit(1);
    } else if (Certificates.Count == 1) {
        Signer.Certificate = Certificates(1);
    } else {
        Certificates =
        Certificates.Select("CSignData.js", "Please select a certificate to sign " +
                                            FileNames[0] + ".");
        if (Certificates.Count == 0) {
            WScript.Echo("Error: Certificate selection dialog was canceled.");
            WScript.Quit(2);
        }
        Signer.Certificate = Certificates(1);
    }

    Certificates = null;
    Store = null;

    Signer.Options = IncludeOption;

}

//   .
if (Command == Sign) {
    DoSignCommand(FileNames, bDetached, Signer);
} else if (Command == CoSign) {
    DoCoSignCommand(FileNames, bDetached, Signer);
} else {
    DoVerifyCommand(FileNames, bDetached, VerifyFlag);
}
//  .
Signer = null;

WScript.Quit(0);

//  main


//------------------------------------------------------------------------------
//  DoSignCommand     FileNames[0]
//      FileNames[1].
//------------------------------------------------------------------------------

function DoSignCommand(FileNames, bDetached, Signer) {
    var Content;
    var Message;
    var SignedData;

    //   SignedData.
    SignedData = new ActiveXObject("CAPICOM.SignedData");

    //   .
    WScript.Echo("Signing text file " + FileNames[0] + ".");
    WScript.Echo();

    //     .
    Content = LoadFile(FileNames[0]);

    // .
    SignedData.Content = Content;
    Message = SignedData.Sign(Signer, bDetached);

    //     FileNames[1].
    SaveFile(FileNames[1], Message);
    WScript.Echo("Successful - Signed message saved to " + FileNames[1] + ".");

    //  .
    SignedData = null;

}
// DoSignCommand


//------------------------------------------------------------------------------
//  DoCoSignCommand    FileNames[0] 
//     FileNames[1].
//------------------------------------------------------------------------------

function DoCoSignCommand(FileNames, bDetached, Signer) {
    var Content;
    var Message;
    var SignedData;

    //   SignedData.
    SignedData = new ActiveXObject("CAPICOM.SignedData");

    //   .
    WScript.Echo("CoSigning text file " + FileNames[0] + ".");
    WScript.Echo();


    //   .
    Message = LoadFile(FileNames[0]);

    //   
    if (bDetached) {
        Content = LoadFile(FileNames[1]);
        SignedData.Content = Content;
        WScript.Echo("content file " + FileNames[1] + ".");
    }

    //   .
    SignedData.Verify(Message, bDetached, VerifyFlag);

    //  .
    Message = SignedData.CoSign(Signer, bDetached);

    //      FileNames[0].
    SaveFile(FileNames[0], Message);
    WScript.Echo("Successful - CoSigned message saved to " + FileNames[0] +
                 ".");

    //  .
    SignedData = null;

}
//  DoCoSignCommand


//------------------------------------------------------------------------------
//  DoVerifyCommand    .
//------------------------------------------------------------------------------

function DoVerifyCommand(FileNames, bDetached, VerifyFlag) {
    var Content;
    var Message;
    var SignedData;

    //   SignedData.
    SignedData = new ActiveXObject("CAPICOM.SignedData");

    //   .
    WScript.Echo("Verifying signed text file " + FileNames[0] +
                 ", please wait...");
    WScript.Echo();

    //     .
    Message = LoadFile(FileNames[0]);

    //   
    if (bDetached) {
        Content = LoadFile(FileNames[1]);
        SignedData.Content = Content;
    }

    //  .
    SignedData.Verify(Message, bDetached, VerifyFlag);


    //     FileNames[1].
    if (!bDetached) {
        SaveFile(FileNames[1], SignedData.Content);
        WScript.Echo("Successful - Verified content saved to " + FileNames[1] +
                     ".");
    } else {
        WScript.Echo("Successful.");
    }

    //  .
    SignedData = null;

}
//  DoVerifyCommand

//------------------------------------------------------------------------------
// LoadFile    .
//------------------------------------------------------------------------------

function LoadFile(FileName) {
    var fso;
    fso = new ActiveXObject("Scripting.FileSystemObject");

    if (!fso.FileExists(FileName)) {
        WScript.Echo("Error: File " + FileName + " not found.");
        WScript.Quit(-5);
    }

    var ts;
    ts = fso.OpenTextFile(FileName, ForReading);
    Buffer = ts.ReadAll();
    return Buffer;

}
//  LoadFile


//------------------------------------------------------------------------------
//  SaveFile    .
//------------------------------------------------------------------------------

function SaveFile(FileName, Buffer) {
    var fso;
    fso = new ActiveXObject("Scripting.FileSystemObject");

    var ts;
    ts = fso.OpenTextFile(FileName, ForWriting, true);
    ts.Write(Buffer);

}
//  SaveFile


//------------------------------------------------------------------------------
//  ParseCommandLine     
//   .
//------------------------------------------------------------------------------

function ParseCommandLine() {

    //    ,   .
    var ARG_STATE_COMMAND = 0;
    var ARG_STATE_OPTIONS = 1;
    var ARG_STATE_FILENAME = 13;

    //   .
    var Arg;
    var ArgState = ARG_STATE_COMMAND;
    var tmp = new Array(2);

    for (var i = 0; i < WScript.Arguments.length; i++) {
        Arg = WScript.Arguments(i);
        if (ArgState == ARG_STATE_COMMAND) {
            if (Arg.toLowerCase() == "sign") {
                Command = Sign;
            } else if (Arg.toLowerCase() == "cosign") {
                Command = CoSign;
            } else if (Arg.toLowerCase() == "verify") {
                Command = Verify;
            } else {
                DisplayUsage();
            }
            ArgState = ARG_STATE_OPTIONS;
        } else if (ArgState == ARG_STATE_OPTIONS) {
            if (Arg.toLowerCase() == "-?" || Arg.toLowerCase() == "/?") {
                DisplayUsage();
            } else {
                if (Arg.substring(0, 1) == "-" || Arg.substring(0, 1) == "/") {
                    DisplayUsage();
                } else {
                    FileNames = new Array(1);
                    FileNames[0] = Arg;
                    tmp[0] = Arg;
                }
                ArgState = ARG_STATE_FILENAME;
            }
        } else if (ArgState == ARG_STATE_FILENAME) {
            if (Arg.substring(0, 1) == "-" || Arg.substring(0, 1) == "/") {
                DisplayUsage();
            } else {
                FileNames = new Array(2);
                FileNames[0] = tmp[0];
            }
            FileNames[1] = Arg;
        } else {
            WScript.Echo("Internal script error: Unknown argument state (" +
                         CStr(ArgState) + ") encountered.");
            WScript.Quit(-3);
        }
    }

    //   .
    if (ArgState != ARG_STATE_FILENAME) {
        DisplayUsage();
    }

    //  .
    if (Command == Sign || Command == Verify) {
        //           (   ) .
        if (FileNames.length != 2) {
            DisplayUsage();
        }
    }
}
//  ParseCommandLine

//------------------------------------------------------------------------------
//  DisplayUsage     
// ,      .
//------------------------------------------------------------------------------

function DisplayUsage() {
    var ss;
    if (Command == Unknown) {
        ss = "Usage: CSignData Command File1 [File2]\n\n" +
             "Command:\n" +
             "  Sign   \t -- Sign a text file\n" +
             "  CoSign \t -- CoSign a signed text file\n" +
             "  Verify \t -- Verify a signed text file\n\n" +
             "For help on a specific command, enter \"CSignData Command -?\"";
        WScript.echo(ss);
    } else if (Command == Sign) {
        ss = "Usage: CSignData Sign ContentFile SignedFile\n" +
             "The Sign command is used to sign a text file. Signing protects a file from\n" +
             "tampering, and allows user to verify the signer based on signing certificate.\n" +
             "For non-detached signing, both the content and signature will be saved to\n" +
             "SignedFile. For detached signing, only the signature is saved to SignedFile.\n\n" +
             "Parameters:\n" +
             "  -?          \t -- This help screen\n" +
             "  ContentFile \t -- Text file to be signed\n" +
             "  SignedFile  \t -- Signed file (contains signature only if (detached)\n\n" +
             "Note: All non-fatal invalid options for this specific command will be ignored,\n" +
             "      and the ** symbol indicates option can be listed multiple times.\n" +
             "      if (there is only one certificate found in the MY store or PFX that\n" +
             "      matches the requirement, that particular certificate will be used.\n" +
             "      However, if (there is more than one certificate matching the requirement,\n" +
             "      a dialog will be displayed to allow selection of the signing certificate.";
        WScript.echo(ss);
    } else if (Command == CoSign) {
        ss = "Usage: CSignData CoSign SignedFile [ContentFile]\n" +
             "The CoSign command is used to cosign a signed text file. CoSigning provides the\n" +
             "same type of benefits as signing, with an additional signature.\n" +
             "For non-detached cosigning, both the content and signatures will be saved to\n" +
             "SignedFile. For detached cosigning, only the signatures are saved to\n" +
             "SignedFile.\n\n" +
             "Parameters:\n" +
             "  -?          \t -- This help screen\n" +
             "  SignedFile  \t -- Signed file (contains signature only if (detached)\n" +
             "  ContentFile \t -- Text file (required if (detached)\n\n" +
             "Note: All non-fatal invalid options for this specific command will be ignored,\n" +
             "      and the ** symbol indicates option can be listed multiple times.\n" +
             "      if (there is only one certificate found in the MY store or PFX that\n" +
             "      matches the requirement, that particular certificate will be used.\n" +
             "      However, if (there is more than one certificate matching the requirement,\n" +
             "      a dialog will be displayed to allow selection of the signing certificate.";
        WScript.echo(ss);
    } else if (Command == Verify) {
        ss = "Usage: CSignData Verify SignedFile ContentFile\n" +
             "The Verify command is used to verify signed text file. Verification checks\n" +
             "integrity of the signed file and determines if (the signing certificate is\n" +
             "valid and issued by a trusted party.\n" +
             "For non-detached signed file, the content will be extracted and saved to\n" +
             "ContentFile. For detached signed file, the ContentFile is not modified.\n\n" +
             "Parameters:\n" +
             "  -?                     -- This help screen\n" +
             "  SignedFile             -- Signed file (contains signature only if (detached)\n" +
             "  ContentFile            -- Text file (will not be over written if (detached)\n\n" +
             "Note: All non-fatal invalid options for this specific command will be ignored.";
        WScript.echo(ss);
    } else {
        WScript.echo("Internal script error: Unknown help state (Command = " +
                     CStr(Command) + ").");
        WScript.Quit(-2);
    }
    WScript.Quit(-1);

}
//  DisplayUsage
//  
