package JCPLog;

/**
 * Created by elvira on 07.12.2017.
 */


import ru.CryptoPro.JCP.JCP;
import ru.CryptoPro.JCP.tools.JCPLogger;
import wss4j.config.XmlContainer;
import xades.config.IXAdESConfig;

import java.security.*;
import java.security.cert.*;
import java.util.*;

public class LogPerformanceExample {

    public static void main(String[] args) throws Exception {

        IXAdESConfig container = XmlContainer.createContainer(XmlContainer.KeyType.kt2001);

        // Инициализация ключевого контейнера.
        KeyStore keyStore = KeyStore.getInstance(JCP.HD_STORE_NAME);
        keyStore.load(null, null);

        // Получение ключа и сертификата.
        PrivateKey privateKey = (PrivateKey)keyStore.getKey(container.getSignatureContainer().getAlias(),
                container.getSignatureContainer().getPassword());

        X509Certificate cert = (X509Certificate) keyStore.getCertificate(
                container.getSignatureContainer().getAlias());
        Date validationDate = new Date();
        long base = System.currentTimeMillis();
        for (int i = 0; i < 100; i++){
            JCPLogger.subTraceFormat("%%% Verifying the certificate chain for the target certificate\n\tserial number: {0}\n\tsubject: {1}\n\tissuer: {2}\n\tsignature provider: {3}\n\tvalidation date: {4}\n\trevocation algorithm: {5}\n\trevocation validator: {6}\n\tonline: {7}\n\t%%%"
                    , cert.getSerialNumber().toString(16), cert.getSubjectDN(), cert.getIssuerDN(), "JCP", validationDate, "CPPKIX", "RevCheck", true);
        }
        long result1 = System.currentTimeMillis() - base;

        base = System.currentTimeMillis();
        for (int i = 0; i < 100; i++){
            JCPLogger.subTrace("%%% Verifying the certificate chain for " +
                    "the target certificate" +
                    "\n\tserial number: " + cert.getSerialNumber().toString(16) +
                    "\n\tsubject: " + cert.getSubjectDN() +
                    "\n\tissuer: " + cert.getIssuerDN() +
                    "\n\tsignature provider: " + "JCP" +
                    "\n\tvalidation date: " + validationDate +
                    "\n\trevocation algorithm: " + "CPPKIX" +
                    "\n\trevocation validator: " + "RevCheck" +
                    "\n\tonline: " + true +
                    "\n\t%%%");
        }
        long result2 = System.currentTimeMillis() - base;


        base = System.currentTimeMillis();
        for (int i = 0; i < 100; i++){
            JCPLogger.subTrace("%%% Verifying the certificate chain for the target certificate");
            JCPLogger.subTrace("serial number: " + cert.getSerialNumber().toString(16) );
            JCPLogger.subTrace("subject: " + cert.getSubjectDN() );
            JCPLogger.subTrace("issuer: " + cert.getIssuerDN() );
            JCPLogger.subTrace("signature provider: " + "JCP" );
            JCPLogger.subTrace("validation date: " + validationDate );
            JCPLogger.subTrace("revocation algorithm: " + "CPPKIX" );
            JCPLogger.subTrace("revocation validator: " + "RevCheck" );
            JCPLogger.subTrace("tonline: " + true );
            JCPLogger.subTrace("%%%");
        }
        long result3 = System.currentTimeMillis() - base;


        base = System.currentTimeMillis();
        for (int i = 0; i < 100; i++){
            JCPLogger.subTrace("%%% Verifying the certificate chain for the target certificate");
            JCPLogger.subTrace("serial number: " , cert.getSerialNumber().toString(16) );
            JCPLogger.subTrace("subject: " , cert.getSubjectDN() );
            JCPLogger.subTrace("issuer: " , cert.getIssuerDN() );
            JCPLogger.subTrace("signature provider: " , "JCP" );
            JCPLogger.subTrace("validation date: " , validationDate );
            JCPLogger.subTrace("revocation algorithm: " , "CPPKIX" );
            JCPLogger.subTrace("revocation validator: " , "RevCheck" );
            JCPLogger.subTrace("tonline: " , true );
            JCPLogger.subTrace("%%%");
        }
        long result4 = System.currentTimeMillis() - base;

        base = System.currentTimeMillis();
        for (int i = 0; i < 100; i++){
            JCPLogger.subTrace("%%% Verifying the certificate chain for the target certificate");
            JCPLogger.subTraceFormat("serial number: {0}", cert.getSerialNumber().toString(16));
            JCPLogger.subTraceFormat("subject: {0}", cert.getSubjectDN());
            JCPLogger.subTraceFormat("issuer: {0}", cert.getIssuerDN());
            JCPLogger.subTraceFormat("signature provider: {0}", "JCP");
            JCPLogger.subTraceFormat("validation date: {0}", validationDate);
            JCPLogger.subTraceFormat("revocation algorithm: {0}", "CPPKIX");
            JCPLogger.subTraceFormat("revocation validator: {0}", "RevCheck");
            JCPLogger.subTraceFormat("online: {0}", true );
            JCPLogger.subTrace("%%%");
        }
        long result5 = System.currentTimeMillis() - base;

        System.out.println("Result1: "+ result1);
        System.out.println("Result2: "+ result2);
        System.out.println("Result3: "+ result3);
        System.out.println("Result4: "+ result4);
        System.out.println("Result5: "+ result5);
    }

}
