/**
 * $RCSfileHashExample.java,v $
 * version $Revision: 36379 $
 * created 21.08.2017 13:12 by afevma
 * last modified $Date: 2012-05-30 12:19:27 +0400 (Ср, 30 май 2012) $ by $Author: afevma $
 * <p/>
 * Copyright 2004-2017 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package ru.CryptoPro.ACSPInClientApp.examples;

import ru.CryptoPro.ACSPInClientApp.interfaces.Executable;
import ru.CryptoPro.ACSPInClientApp.tools.Logger;

import ru.CryptoPro.JCP.JCP;
import ru.CryptoPro.JCSP.JCSP;

import java.security.MessageDigest;

/**
 * Пример HashExample предназначен для
 * создания хеша ГОСТ Р 34.11-2012 (256).
 *
 * @author Copyright 2004-2017 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class HashExample implements Executable<Void> {

    @Override
    public Void execute() throws Exception {

        Logger.INSTANCE.append("Initializing message digest...");

        MessageDigest md = MessageDigest.getInstance(
            JCP.GOST_DIGEST_2012_256_NAME,
            JCSP.PROVIDER_NAME
        );

        md.update("test".getBytes());
        byte[] digest = md.digest();

        Logger.INSTANCE.append("Message digest completed: "
            + digest.length + " bytes");

        return null;

    }

}
