/**
 * $RCSfileLogger.java,v $
 * version $Revision: 36379 $
 * created 21.08.2017 13:15 by afevma
 * last modified $Date: 2012-05-30 12:19:27 +0400 (Ср, 30 май 2012) $ by $Author: afevma $
 * <p/>
 * Copyright 2004-2017 Crypto-Pro. All rights reserved.
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package ru.CryptoPro.ACSPInClientApp.tools;

import android.util.Log;
import android.widget.TextView;

/**
 * Служебный класс Logger предназначен
 * для логирования операций.
 *
 * @author Copyright 2004-2017 Crypto-Pro. All rights reserved.
 * @.Version
 */
public class Logger {

    /**
     * Тэг лога.
     */
    public static final String LOG_TAG = "ACSP_Embedded";

    /**
     * Поле лога.
     */
    private TextView logger;

    /**
     * Экземпляр лога.
     */
    public static Logger INSTANCE;

    /**
     * Создание экземпляра лога.
     *
     * @param log Поле лога.
     */
    public static void init(TextView log) {
        INSTANCE = new Logger(log);
    }

    /**
     * Конструктор.
     *
     * @param log Поле лога.
     */
    private Logger(TextView log) {
        logger = log;
    }

    /**
     * Очистка поля.
     */
    public void clear() {

        logger.post(new Runnable() {

            public void run() {
                logger.setText("");
            }

        });

    };

    /**
     * Добавление сообщений в лог.
     *
     * @param message Сообщение.
     */
    public void append(final String message) {

        if (message != null) {

            Log.d(LOG_TAG, message);

            logger.post(new Runnable() {

                @Override
                public void run() {
                    logger.append(message + "\n");
                }

            });

        }

    }

}
