/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import sun.security.pkcs.PKCS10;
import sun.security.x509.X500Name;

import java.io.FileOutputStream;
import java.io.PrintStream;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.Signature;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;

/**
 * В данном примере используется внутренний sun - PKCS10.
 * Вместо него ремоендуется использовать GostCertificateRequest
 * из состава JCP.
 *
 */
public class CertReq {
  public static void main(String[] args) {
      long startTime = General.printTestName("CertReq");
	try {
        String alias = "mykey";
	    String password = "password";
	    String sigAlgName = "SHA1WithDSA";
        String filename = "request";
	    PrintStream out =  new  PrintStream(new FileOutputStream(filename));
        KeyStore keyStore = General.LoadKeyStore(password);
        PrivateKey privKey = General.GetPrivateFromStore(keyStore, alias, password);
	    Certificate cert = keyStore.getCertificate(alias);
        PKCS10 request = new PKCS10(cert.getPublicKey());
        Signature signature = Signature.getInstance(sigAlgName);
	    signature.initSign(privKey);
	    X500Name subject =
	    new X500Name(((X509Certificate)cert).getSubjectDN().toString());
        request.encodeAndSign(subject, signature);
	    request.print(out);
        General.printOK(startTime);
	}
	
	catch( Exception ex )
	{
		General.printEx(ex, startTime);
	}
    }	
}
