/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.JCP;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.security.DigestInputStream;
import java.security.MessageDigest;

public class Digest {

    public static final String text = "Generating message digest example.";

    /**
     * @param args
     * @throws IOException
     */
    public static void main(String[] args) throws IOException {
        main_(JCP.GOST_DIGEST_NAME);
        main_(JCP.GOST_DIGEST_2012_256_NAME);
        main_(JCP.GOST_DIGEST_2012_512_NAME);
    }

    /**
     * Хеширование данных.
     *
     * @param AlgDigest Алгоритм хеширования.
     * @throws IOException
     */
    public static void main_(String AlgDigest) throws IOException {

	    long startTime = General.printTestName("Digest_" + AlgDigest);
        ByteArrayInputStream stream = new ByteArrayInputStream(text.getBytes());
        int size = stream.available();

        try {
            MessageDigest sha = MessageDigest.getInstance(AlgDigest);
            DigestInputStream digest  = new DigestInputStream(stream, sha);
            digest.setMessageDigest(sha);
            int count;
            byte temp[] = new byte[256];
            do
            count = digest.read(temp, 0, 256);
            while (count == 256);
            sha = digest.getMessageDigest();
            byte[] res = sha.digest();
            System.out.println( General.toHexString( res ) );
            General.printOK(startTime, size);
	    }
	    catch(Exception ex) {
	        General.printEx(ex, startTime, size);
        }

    }	
}