/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.Digest.GostDigest;
import ru.CryptoPro.JCP.params.OID;

import java.security.*;
import java.io.*;
import java.lang.*;

public class Digest50bytes {

    public static void main(String[] args) {
    long startTime = General.printTestName("Digest50bytes");
        try {
            String AlgDigest =  "GOST3411";
            byte [] test_text ={
                0x53,0x75,0x70,0x70,0x6F,0x73,0x65,0x20,
                0x74,0x68,0x65,0x20,0x6F,0x72,0x69,0x67,
                0x69,0x6E,0x61,0x6C,0x20,0x6D,0x65,0x73,
                0x73,0x61,0x67,0x65,0x20,0x68,0x61,0x73,
                0x20,0x6C,0x65,0x6E,0x67,0x74,0x68,0x20,
                0x3D,0x20,0x35,0x30,0x20,0x62,0x79,0x74,
                0x65,0x73
            };
            byte [] test_result ={
                    (byte) 0x47, (byte) 0x1A, (byte) 0xBA, (byte) 0x57, (byte) 0xA6, (byte) 0x0A, (byte) 0x77, (byte) 0x0D,
                    (byte) 0x3A, (byte) 0x76, (byte) 0x13, (byte) 0x06, (byte) 0x35, (byte) 0xC1, (byte) 0xFB, (byte) 0xEA,
                    (byte) 0x4E, (byte) 0xF1, (byte) 0x4D, (byte) 0xE5, (byte) 0x1F, (byte) 0x78, (byte) 0xB4, (byte) 0xAE,
                    (byte) 0x57, (byte) 0xDD, (byte) 0x89, (byte) 0x3B, (byte) 0x62, (byte) 0xF5, (byte) 0x52, (byte) 0x08,
            };
            MessageDigest sha = MessageDigest.getInstance(AlgDigest);
            ((GostDigest)sha).reset(new OID("1.2.643.2.2.30.0"));
            ByteArrayInputStream stream = new ByteArrayInputStream(test_text);
            DigestInputStream digest  = new DigestInputStream(stream, sha);
            digest.setMessageDigest(sha);
            byte temp[] = new byte[50];
            digest.read(temp, 0, 50);
            sha = digest.getMessageDigest();
            byte[] res = sha.digest();
            if (res.length != 32)
                throw new Exception("The length of digest is invalid");
            for (int i = 0; i<32; i++)
            {
                if (res[i] != test_result[i])
                        throw new Exception("The digest is invalid");
            }
            System.out.println( General.toHexString( res ) );
            General.printOK(startTime);

            }
            catch( Exception ex )
            {
                General.printEx(ex, startTime);
        }
        }
}