/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.JCP;

import java.security.*;
import java.io.*;
import java.lang.*;

public class SignWithCert{
public static final String text = "Example of generating and verifing signature.";
    public static void main(String[] args) {
        long startTime = General.printTestName("SignWithCert");
        try {
            int keysize = 512;
            int validity = 90;
            String password = "password";
            String alias = "elvira_key";
            String AlgSign = JCP.GOST_EL_SIGN_NAME;
            String AlgKey = JCP.GOST_EL_DEGREE_NAME;
            String certfilename = "cert.cer";
            String filesign = "signatureCert.txt";
            General.SetStoreEntry(AlgKey, AlgSign, keysize, validity, alias, password, certfilename);
            KeyStore keyStore = General.LoadKeyStore(password);
            PrivateKey priv = General.GetPrivateFromStore(keyStore, alias, password);
            Signature test = Signature.getInstance(AlgSign);
            test.initSign(priv);
            test.update(text.getBytes());
            byte[] sig = test.sign();
            System.out.println( General.toHexString( sig ) );
            FileOutputStream file = new FileOutputStream(filesign);
            file.write(sig);
            General.printOK(startTime);
        }
	catch( Exception ex )
	{
		General.printEx(ex, startTime);
	}
    }	
}