/**
 * Программный код, содержащийся в этом файле, предназначен
 * для целей обучения. Может быть скопирован или модифицирован
 * при условии сохранения абзацев с указанием авторства и прав.
 *
 * Данный код не может быть непосредственно использован
 * для защиты информации. Компания Крипто-Про не несет никакой
 * ответственности за функционирование этого кода.
 */
package oldSamples;

import ru.CryptoPro.JCP.JCP;

import java.security.*;
import java.io.*;
import java.lang.*;
import java.security.spec.*;

public class Verify{
public static final String text = "Example of generating and verifing signature.";
    public static void main(String[] args) {
        long startTime = General.printTestName("Verify");
        try {
        String AlgSign = JCP.CRYPTOPRO_SIGN_NAME;
        String AlgKey = JCP.GOST_EL_DEGREE_NAME;
        String fileparam = "pubKeyParam.bin";
        String filesign = "signature.txt";
		Signature sig = Signature.getInstance(AlgSign);
        byte signature[] = General.fileRead(filesign);
		FileInputStream pubKeyParam = new FileInputStream(fileparam);
		DataInputStream data_stream = new DataInputStream( pubKeyParam );
		int len = data_stream.readInt();
        byte param[] = new byte[len];
		data_stream.read(param);
		X509EncodedKeySpec pubKeySpec = new X509EncodedKeySpec(param);
    	KeyFactory keyFactory = KeyFactory.getInstance(AlgKey);
   	 	PublicKey pub = keyFactory.generatePublic(pubKeySpec);
		sig.initVerify(pub);
        byte src[] = text.getBytes();
		sig.update(src);
		boolean verifies = sig.verify(signature);
		System.out.println("signature verifies: " + verifies);
        if (verifies == false)
        {
             throw new Exception("Signature was not verified");
        }
        General.printOK(startTime);
	}
	catch( Exception ex )
	{
        General.printEx(ex, startTime);
	}
    }	
}